
#include <assert.h>

#include "interpolate.h"

#include <math.h>
static double scale0, scale, N_d;
static int N;

void init_dct (int N_init) {
    N_d = N_init;
    N = N_init;
    scale0 = sqrt (1.0 / N);
    scale = sqrt (2.0 / N);
}

int *dct (short  *idata) {
    int *odata = malloc (N * sizeof (int));
    double out_val;
    int n, k;
    for (k = 0; k < N; k++) {
        out_val = 0;
        for (n = 0; n < N; n++) {
            out_val += idata[n] * cos ((M_PI / N) * k * (n + 0.5));
        }
        if (k == 0)
            out_val *= scale0;
        else
            out_val *= scale;
        odata[k] = (int) out_val;
    }
    return odata;
}

int check (int *idata1, int *idata2) {
    int i;
    for (i = 0; i < N; i++) {
        if ((idata1[i] - idata2[i] < 1) || (idata1[i] - idata2[i] > 1))
            return 0;
    }
    return 1;
}

short  *idct (int *idata) {
    short  *odata = malloc (N * sizeof (short ));
    double out_val;
    int n, k;
    for (k = 0; k < N; k++) {
        out_val = idata[0] / 2.0;
        for (n = 1; n < N; n++) {
            out_val += idata[n] * cos ((M_PI / N) * n * (k + 0.5));
        }
        if (k == 0)
            out_val *= scale0;
        else
            out_val *= scale;
        odata[k] = (short ) out_val;
    }
    int *newIdata = dct (odata);
    if (!check (idata, newIdata)) {
        printf ("lost quality\n");
    }
    return odata;
}

